<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processor.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processor.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processor.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2003 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">import</span> IR</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/Error.html">Error</a>(Exception):</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">   <span class="py-string">&quot;&quot;&quot;An exception a processor may raise during processing.&quot;&quot;&quot;</span></span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Error.html#__init__">__init__</a>(self, what):</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">      self.what = what</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Error.html#__str__">__str__</a>(self):</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">      <span class="py-keyword">return</span> <span class="py-string">&quot;%s: %s&quot;</span>%(self.__class__.__name__, self.what)</span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/InvalidArgument.html">InvalidArgument</a>(Error): <span class="py-keyword">pass</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/MissingArgument.html">MissingArgument</a>(Error): <span class="py-keyword">pass</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/InvalidCommand.html">InvalidCommand</a>(Error): <span class="py-keyword">pass</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/InternalError.html">InternalError</a>(Error): <span class="py-keyword">pass</span></span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/Parameter.html">Parameter</a>(object):</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A Parameter is a documented value, kept inside a Processor.&quot;&quot;&quot;</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Parameter.html#__init__">__init__</a>(self, value, doc):</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">      self.value = value</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">      self.doc = doc</span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/Type.html">Type</a>(type):</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Type is the Processor's __metaclass__.&quot;&quot;&quot;</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Type.html#__init__">__init__</a>(cls, name, bases, dict):</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Generate a '_parameters' dictionary holding all the 'Parameter' objects.</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-string">      Then replace 'Parameter' objects by their values for convenient use inside</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="py-string">      the code.&quot;&quot;&quot;</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">      parameters = {}</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> dict:</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">         <span class="py-keyword">if</span> isinstance(dict[i], Parameter):</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">            parameters[i] = dict[i]</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> parameters:</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">         setattr(cls, i, dict[i].value)</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">      setattr(cls, <span class="py-string">'_parameters'</span>, parameters)</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/Parametrized.html">Parametrized</a>(object):</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Parametrized implements handling of Parameter attributes.&quot;&quot;&quot;</span></span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">   __metaclass__ = Type</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Parametrized.html#__new__">__new__</a>(cls, *args, **kwds):</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">      <span class="py-string">&quot;&quot;&quot;merge all parameter catalogs for easy access to documentation,</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line"><span class="py-string">      then use keyword arguments to override default values.&quot;&quot;&quot;</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">      instance = object.__new__(cls)</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">      <span class="py-comment"># iterate over all base classes, starting at the 'Parametrized' base class</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">      <span class="py-comment"># i.e. remove mixin classes</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">      hierarchy = list(filter(<span class="py-keyword">lambda</span> i:issubclass(i, Parametrized), cls.__mro__))</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">      hierarchy.reverse()</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">      parameters = {}</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">      <span class="py-keyword">for</span> c <span class="py-keyword">in</span> hierarchy:</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">         parameters.update(c._parameters)</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">      setattr(instance, <span class="py-string">'_parameters'</span>, parameters)</span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> kwds:</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">         <span class="py-keyword">if</span> <span class="py-keyword">not</span> p <span class="py-keyword">in</span> instance._parameters:</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">            <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'&quot;%s.%s&quot; processor does not have &quot;%s&quot; parameter'</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">                                  %(cls.__module__, cls.__name__, p))</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">            setattr(instance, p, kwds[p])</span>
<a id="line69"></a><span class="lineno"> 69</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">      <span class="py-keyword">return</span> instance</span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Parametrized.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">      <span class="py-string">&quot;&quot;&quot;The constructor uses the keywords to update the parameter list.&quot;&quot;&quot;</span></span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Parametrized.html#clone">clone</a>(self, *args, **kwds):</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Create a copy of this Parametrized.</span></span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line"><span class="py-string">      The only copied attributes are the ones corresponding to parameters.&quot;&quot;&quot;</span></span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">      new_kwds = dict([(k, getattr(self, k)) <span class="py-keyword">for</span> k <span class="py-keyword">in</span> self._parameters])</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">      new_kwds.update(kwds)</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">      <span class="py-keyword">return</span> type(self)(*args, **new_kwds)</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Parametrized.html#get_parameters">get_parameters</a>(self):</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">      <span class="py-keyword">return</span> self._parameters</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Parametrized.html#set_parameters">set_parameters</a>(self, kwds):</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Sets the given parameters to override the default values.&quot;&quot;&quot;</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> kwds:</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">         <span class="py-keyword">if</span> i <span class="py-keyword">in</span> self._parameters:</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">            setattr(self, i, kwds[i])</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">            <span class="py-keyword">raise</span> InvalidArgument, <span class="py-string">&quot;No parameter '%s' in '%s'&quot;</span>%(i, self.__class__.__name__)</span>
<a id="line97"></a><span class="lineno"> 97</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/Processor.html">Processor</a>(Parametrized):</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Processor documentation...&quot;&quot;&quot;</span></span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">   verbose = Parameter(False, <span class="py-string">&quot;operate verbosely&quot;</span>)</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">   debug = Parameter(False, <span class="py-string">&quot;generate debug traces&quot;</span>)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">   profile = Parameter(False, <span class="py-string">&quot;output profile data&quot;</span>)</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">   input = Parameter([], <span class="py-string">&quot;input files to process&quot;</span>)</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">   output = Parameter(<span class="py-string">''</span>, <span class="py-string">&quot;output file to save the ir to&quot;</span>)</span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Processor.html#merge_input">merge_input</a>(self, ir):</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Join the given IR with a set of IRs to be read from 'input' parameter&quot;&quot;&quot;</span></span>
<a id="line110"></a><span class="lineno">110</span><span class="line">      input = getattr(self, <span class="py-string">'input'</span>, [])</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">      <span class="py-keyword">for</span> file <span class="py-keyword">in</span> input:</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">         <span class="py-keyword">try</span>:</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">            ir.merge(IR.load(file))</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">         <span class="py-keyword">except</span>:</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'unable to load IR from %s'</span>%file)</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">      <span class="py-keyword">return</span> ir</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Processor.html#output_and_return_ir">output_and_return_ir</a>(self):</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">      <span class="py-string">&quot;&quot;&quot;writes output if the 'output' attribute is set, then returns&quot;&quot;&quot;</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line">      output = getattr(self, <span class="py-string">'output'</span>, None)</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">      <span class="py-keyword">if</span> output:</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">         self.ir.save(output)</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">      <span class="py-keyword">return</span> self.ir</span>
<a id="line124"></a><span class="lineno">124</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Processor.html#process">process</a>(self, ir, **kwds):</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">      <span class="py-string">&quot;&quot;&quot;The process method provides the interface to be implemented by subclasses.</span></span>
<a id="line127"></a><span class="lineno">127</span><span class="line"><span class="py-string">      </span></span>
<a id="line128"></a><span class="lineno">128</span><span class="line"><span class="py-string">      Commonly used arguments are 'input' and 'output'. If 'input' is defined,</span></span>
<a id="line129"></a><span class="lineno">129</span><span class="line"><span class="py-string">      it is interpreted as one or more input file names. If 'output' is defined, it</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line"><span class="py-string">      is interpreted as an output file (or directory) name.</span></span>
<a id="line131"></a><span class="lineno">131</span><span class="line"><span class="py-string">      This implementation may serve as a template for real processors.&quot;&quot;&quot;</span></span>
<a id="line132"></a><span class="lineno">132</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">      <span class="py-comment"># override default parameter values</span></span>
<a id="line134"></a><span class="lineno">134</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">      <span class="py-comment"># merge in IR from 'input' parameter if given</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line">      self.ir = self.merge_input(ir)</span>
<a id="line137"></a><span class="lineno">137</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">      <span class="py-comment"># do the real work here...</span></span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">      <span class="py-comment"># write to output (if given) and return IR</span></span>
<a id="line141"></a><span class="lineno">141</span><span class="line">      <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line142"></a><span class="lineno">142</span>
<a id="line143"></a><span class="lineno">143</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/Composite.html">Composite</a>(Processor):</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A Composite processor.&quot;&quot;&quot;</span></span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">   processors = Parameter([], <span class="py-string">'the list of processors this is composed of'</span>)</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Composite.html#__init__">__init__</a>(self, *processors, **kwds):</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">      <span class="py-string">&quot;&quot;&quot;This __init__ is a convenience constructor that takes a var list</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line"><span class="py-string">      to list the desired processors. If the named values contain 'processors',</span></span>
<a id="line151"></a><span class="lineno">151</span><span class="line"><span class="py-string">      they override the var list.&quot;&quot;&quot;</span></span>
<a id="line152"></a><span class="lineno">152</span><span class="line">      <span class="py-keyword">if</span> processors: self.processors = processors</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line154"></a><span class="lineno">154</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Composite.html#process">process</a>(self, ir, **kwds):</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">      <span class="py-string">&quot;&quot;&quot;apply a list of processors. The 'input' value is passed to the first</span></span>
<a id="line157"></a><span class="lineno">157</span><span class="line"><span class="py-string">      processor only, the 'output' to the last. 'verbose' and 'debug' are</span></span>
<a id="line158"></a><span class="lineno">158</span><span class="line"><span class="py-string">      passed down if explicitely given as named values.</span></span>
<a id="line159"></a><span class="lineno">159</span><span class="line"><span class="py-string">      All other keywords are ignored.&quot;&quot;&quot;</span></span>
<a id="line160"></a><span class="lineno">160</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.processors:</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">         <span class="py-keyword">return</span> super(Composite, self).process(ir, **kwds)</span>
<a id="line163"></a><span class="lineno">163</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">      <span class="py-keyword">if</span> len(self.processors) == 1:</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">         my_kwds = {}</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">         <span class="py-keyword">if</span> self.input: my_kwds[<span class="py-string">'input'</span>] = self.input</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">         <span class="py-keyword">if</span> self.output: my_kwds[<span class="py-string">'output'</span>] = self.output</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">         <span class="py-keyword">if</span> self.verbose: my_kwds[<span class="py-string">'verbose'</span>] = self.verbose</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">         <span class="py-keyword">if</span> self.debug: my_kwds[<span class="py-string">'debug'</span>] = self.debug</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">         <span class="py-keyword">if</span> self.profile: my_kwds[<span class="py-string">'profile'</span>] = self.profile</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">         <span class="py-keyword">return</span> self.processors[0].process(ir, **my_kwds)</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">      <span class="py-comment"># more than one processor...</span></span>
<a id="line176"></a><span class="lineno">176</span><span class="line">      <span class="py-comment"># call the first, passing the 'input' parameter, if present</span></span>
<a id="line177"></a><span class="lineno">177</span><span class="line">      my_kwds = {}</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">      <span class="py-keyword">if</span> self.input: my_kwds[<span class="py-string">'input'</span>] = self.input</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">      <span class="py-keyword">if</span> self.verbose: my_kwds[<span class="py-string">'verbose'</span>] = self.verbose</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">      <span class="py-keyword">if</span> self.debug: my_kwds[<span class="py-string">'debug'</span>] = self.debug</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">      <span class="py-keyword">if</span> self.profile: my_kwds[<span class="py-string">'profile'</span>] = self.profile</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">      ir = self.processors[0].process(ir, **my_kwds)</span>
<a id="line183"></a><span class="lineno">183</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">      <span class="py-comment"># deal with all between the first and the last;</span></span>
<a id="line185"></a><span class="lineno">185</span><span class="line">      <span class="py-comment"># they only get 'verbose', 'debug', and 'profile' flags</span></span>
<a id="line186"></a><span class="lineno">186</span><span class="line">      my_kwds = {}</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">      <span class="py-keyword">if</span> self.verbose: my_kwds[<span class="py-string">'verbose'</span>] = self.verbose</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">      <span class="py-keyword">if</span> self.debug: my_kwds[<span class="py-string">'debug'</span>] = self.debug</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">      <span class="py-keyword">if</span> self.profile: my_kwds[<span class="py-string">'profile'</span>] = self.profile</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">      <span class="py-keyword">if</span> len(self.processors) &gt; 2:</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">         <span class="py-keyword">for</span> p <span class="py-keyword">in</span> self.processors[1:-1]:</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">            ir = p.process(ir, **my_kwds)</span>
<a id="line193"></a><span class="lineno">193</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">      <span class="py-comment"># call the last, passing the 'output' parameter, if present</span></span>
<a id="line195"></a><span class="lineno">195</span><span class="line">      <span class="py-keyword">if</span> self.output: my_kwds[<span class="py-string">'output'</span>] = self.output</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">      ir = self.processors[-1].process(ir, **my_kwds)</span>
<a id="line197"></a><span class="lineno">197</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">      <span class="py-keyword">return</span> ir</span>
<a id="line199"></a><span class="lineno">199</span>
<a id="line200"></a><span class="lineno">200</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/Processor/Store.html">Store</a>(Processor):</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Store is a convenience class useful to write out the intermediate</span></span>
<a id="line202"></a><span class="lineno">202</span><span class="line"><span class="py-string">   state of the IR within a pipeline such as represented by the 'Composite'&quot;&quot;&quot;</span></span>
<a id="line203"></a><span class="lineno">203</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/Processor/Store.html#process">process</a>(self, ir, **kwds):</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Simply store the current IR in the 'output' file.&quot;&quot;&quot;</span></span>
<a id="line206"></a><span class="lineno">206</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">      self.ir = self.merge_input(ir)</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">      <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line210"></a><span class="lineno">210</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
